'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactAutosuggest = require('react-autosuggest');

var _reactAutosuggest2 = _interopRequireDefault(_reactAutosuggest);

var _autocomplete = {
  'container': 'ra_autocomplete__container ra_styles__clearfix',
  'input': 'ra_autocomplete__input ra_styles__pad-1 ra_styles__border-gray',
  'containerOpen': 'ra_autocomplete__containerOpen',
  'suggestionsContainer': 'ra_autocomplete__suggestionsContainer',
  'suggestion': 'ra_autocomplete__suggestion ra_styles__pad-1',
  'suggestionFocused': 'ra_autocomplete__suggestionFocused',
  'sectionTitle': 'ra_autocomplete__sectionTitle',
  'sectionContainer': 'ra_autocomplete__sectionContainer',
  'sectionSuggestionsContainer': 'ra_autocomplete__sectionSuggestionsContainer'
};

var _autocomplete2 = _interopRequireDefault(_autocomplete);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /** Our Autocomplete component is a simple wrapper around react-autosuggest.
                                                                                                                                                                                                                              * Copyright � 2016 Misha Moroshko
                                                                                                                                                                                                                              * Read https://github.com/moroshko/react-autosuggest for documentation
                                                                                                                                                                                                                              */

/**
 * Auto Complete component is a very simple wrapper around the [React-Autosuggest](https://github.com/moroshko/react-autosuggest) component.
 * Read there for more comprehensive documentation.
 */
var Autocomplete = function Autocomplete(_ref) {
  var theme = _ref.theme;

  var props = _objectWithoutProperties(_ref, ['theme']);

  var styles = _extends({}, _autocomplete2.default, theme);
  return _react2.default.createElement(_reactAutosuggest2.default, _extends({}, props, { theme: styles }));
};

Autocomplete.defaultProps = {
  onSuggestionsUpdateRequested: function onSuggestionsUpdateRequested() {},
  shouldRenderSuggestions: function shouldRenderSuggestions(value) {
    return value.trim().length > 0;
  },
  onSuggestionSelected: function onSuggestionSelected() {},
  multiSection: false,
  renderSectionTitle: function renderSectionTitle() {
    throw new Error('`renderSectionTitle` must be provided');
  },
  getSectionSuggestions: function getSectionSuggestions() {
    throw new Error('`getSectionSuggestions` must be provided');
  },

  focusInputOnSuggestionClick: true,
  id: '1'
};

exports.default = Autocomplete;