"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _avatar = {
  "avatar": "ra_avatar__avatar ra_styles__circle ra_styles__white ra_styles__bg-gray",
  "image": "ra_avatar__image ra_styles__circle ra_styles__bg-transparent",
  "letter": "ra_avatar__letter"
};

var _avatar2 = _interopRequireDefault(_avatar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * Avatar component creates a circular area where an image, letter or icon/glyphicon can be presented. Great for user profiles and lists.
 *
 * **NOTE**: children will always take precedence over props passed into component.
 */
var Avatar = function Avatar(_ref) {
  var children = _ref.children;
  var className = _ref.className;
  var icon = _ref.icon;
  var image = _ref.image;
  var title = _ref.title;

  var other = _objectWithoutProperties(_ref, ["children", "className", "icon", "image", "title"]);

  var kids = children;
  if (_react2.default.Children.count(children) === 1 && typeof children === "string") {
    kids = _react2.default.createElement(
      "span",
      { className: _avatar2.default.letter },
      children[0]
    );
  }

  var avatar = null;

  if (typeof image === "string") {
    avatar = _react2.default.createElement("img", { className: _avatar2.default.image, src: image, title: title });
  } else if (image) {
    avatar = image;
  } else if (icon) {
    avatar = icon;
  } else if (title) {
    avatar = _react2.default.createElement(
      "span",
      { className: _avatar2.default.letter },
      title[0]
    );
  }

  var classes = _avatar2.default.avatar;
  if (className) classes += " " + className;

  return _react2.default.createElement(
    "div",
    _extends({ className: classes }, other),
    kids,
    avatar
  );
};

Avatar.defaultProps = {
  className: '',
  icon: ''
};

exports.default = Avatar;