'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactThemeable = require('react-themeable');

var _reactThemeable2 = _interopRequireDefault(_reactThemeable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * A Generic button component.
 */
var Button = function Button(_ref) {
  var className = _ref.className;
  var outline = _ref.outline;
  var href = _ref.href;
  var loading = _ref.loading;
  var primary = _ref.primary;
  var secondary = _ref.secondary;
  var success = _ref.success;
  var warning = _ref.warning;
  var danger = _ref.danger;
  var link = _ref.link;
  var large = _ref.large;
  var small = _ref.small;
  var block = _ref.block;
  var disabled = _ref.disabled;
  var children = _ref.children;

  var props = _objectWithoutProperties(_ref, ['className', 'outline', 'href', 'loading', 'primary', 'secondary', 'success', 'warning', 'danger', 'link', 'large', 'small', 'block', 'disabled', 'children']);

  var theme = (0, _reactThemeable2.default)(props.theme);

  var element = href ? 'a' : 'button';

  var role = void 0;
  if (element === 'a') {
    role = 'button';
  }

  var disabledStyle = disabled || loading ? 'disabled' : '';

  var mainStyle = 'button';
  if (primary) {
    mainStyle = 'primary';
  } else if (secondary) {
    mainStyle = 'secondary';
  } else if (success) {
    mainStyle = 'success';
  } else if (warning) {
    mainStyle = 'warning';
  } else if (danger) {
    mainStyle = 'danger';
  } else if (link) {
    mainStyle = 'link';
  }

  if (outline && !secondary) {
    mainStyle += '_outline';
  }

  var otherProps = _extends({}, props, {
    href: href,
    className: className,
    disabled: disabled || loading,
    role: role
  }, theme(1, mainStyle, disabledStyle));

  return _react2.default.createElement(element, otherProps, children);
};

Button.defaultProps = {
  children: "Default Button",
  className: '',
  outline: false,
  loading: false,
  mini: false,
  primary: false,
  secondary: false,
  success: false,
  warning: false,
  danger: false,
  link: false,
  raised: false,
  large: false,
  small: false,
  disabled: false
};

exports.default = Button;