'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _checkbox = {
  'base': 'ra_checkbox__base ra_styles__marg-b-1',
  'block': 'ra_checkbox__block ra_checkbox__base ra_styles__marg-b-1',
  'inline': 'ra_checkbox__inline ra_checkbox__base ra_styles__marg-b-1',
  'disabled': 'ra_checkbox__disabled ra_styles__gray',
  'label': 'ra_checkbox__label ra_styles__marg-l-1',
  'input': 'ra_checkbox__input'
};

var _checkbox2 = _interopRequireDefault(_checkbox);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

/**
 * Simple component for a basic checkbox
 */
var Checkbox = function Checkbox(_ref) {
  var title = _ref.title;
  var label = _ref.label;
  var disabled = _ref.disabled;
  var inline = _ref.inline;
  var className = _ref.className;

  var other = _objectWithoutProperties(_ref, ['title', 'label', 'disabled', 'inline', 'className']);

  var cx = _bind2.default.bind(_checkbox2.default);
  var componentClass = cx(_defineProperty({
    "block": !inline,
    inline: inline,
    disabled: disabled
  }, className, className));

  title = title ? title : label;

  return _react2.default.createElement(
    'label',
    { className: componentClass, title: title },
    _react2.default.createElement('input', _extends({}, other, { type: 'checkbox', disabled: disabled, className: _checkbox2.default.input })),
    label && _react2.default.createElement(
      'span',
      { className: _checkbox2.default.label },
      label
    )
  );
};

Checkbox.defaultProps = {
  className: '',
  disabled: false,
  inline: false
};

exports.default = Checkbox;