"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _bind = require("classnames/bind");

var _bind2 = _interopRequireDefault(_bind);

var _overlay = require("../overlay");

var _overlay2 = _interopRequireDefault(_overlay);

var _dialog = {
  "base": "ra_dialog__base ra_styles__rounded ra_styles__border ra_styles__pad-2 ra_styles__bg-white",
  "inactive": "ra_dialog__inactive ra_dialog__base ra_styles__rounded ra_styles__border ra_styles__pad-2 ra_styles__bg-white",
  "active": "ra_dialog__active ra_dialog__base ra_styles__rounded ra_styles__border ra_styles__pad-2 ra_styles__bg-white",
  "small": "ra_dialog__small",
  "normal": "ra_dialog__normal",
  "large": "ra_dialog__large",
  "body": "ra_dialog__body ra_styles__pad-2 ra_styles__gray"
};

var _dialog2 = _interopRequireDefault(_dialog);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Dialog = function Dialog(_ref) {
  var body = _ref.body;
  var active = _ref.active;
  var type = _ref.type;
  var children = _ref.children;
  var className = _ref.className;
  var onOverlayClick = _ref.onOverlayClick;

  var props = _objectWithoutProperties(_ref, ["body", "active", "type", "children", "className", "onOverlayClick"]);

  var cx = _bind2.default.bind(_dialog2.default);
  var classNames = cx({
    inactive: !active,
    type: type,
    active: active,
    className: className
  });

  return _react2.default.createElement(
    _overlay2.default,
    { active: active, onClick: onOverlayClick },
    _react2.default.createElement(
      "div",
      { className: classNames },
      _react2.default.createElement(
        "section",
        { className: body },
        children
      )
    )
  );
};

Dialog.defaultProps = {
  active: false,
  type: "normal",
  className: ''
};

exports.default = Dialog;