'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _overlay = require('../overlay');

var _overlay2 = _interopRequireDefault(_overlay);

var _drawer = {
  'container': 'ra_drawer__container',
  'active': 'ra_drawer__active',
  'right': 'ra_drawer__right',
  'left': 'ra_drawer__left'
};

var _drawer2 = _interopRequireDefault(_drawer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Drawer = function Drawer(_ref) {
  var active = _ref.active;
  var className = _ref.className;
  var type = _ref.type;
  var onOverlayClick = _ref.onOverlayClick;

  var props = _objectWithoutProperties(_ref, ['active', 'className', 'type', 'onOverlayClick']);

  var cx = _bind2.default.bind(_drawer2.default);
  var classes = cx({
    container: true,
    left: type == 'left',
    right: type == 'right',
    active: active
  }, className);

  return _react2.default.createElement(
    _overlay2.default,
    { active: active, onClick: onOverlayClick },
    _react2.default.createElement(
      'div',
      { className: classes },
      _react2.default.createElement(
        'aside',
        null,
        props.children
      )
    )
  );
};

Drawer.defaultProps = {
  active: false,
  className: '',
  type: 'left'
};

exports.default = Drawer;