'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _dropdown = {
  'container': 'ra_dropdown__container',
  'content': 'ra_dropdown__content undefined ra_styles__clearfix ra_styles__rounded ra_styles__bg-white ra_styles__z4 ra_styles__cursor-pointer',
  'inactive': 'ra_dropdown__inactive ra_dropdown__content undefined ra_styles__clearfix ra_styles__rounded ra_styles__bg-white ra_styles__z4 ra_styles__cursor-pointer',
  'active': 'ra_dropdown__active ra_dropdown__content undefined ra_styles__clearfix ra_styles__rounded ra_styles__bg-white ra_styles__z4 ra_styles__cursor-pointer',
  'list': 'ra_dropdown__list ra_styles__pad-0 ra_styles__marg-0',
  'item': 'ra_dropdown__item ra_styles__pad-v-1 ra_styles__pad-h-2 ra_styles__hover-white ra_styles__hover-bg-blue'
};

var _dropdown2 = _interopRequireDefault(_dropdown);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; } /*
                                                                                                                                                                                                                             Dropdown inspired and mostly taken from:
                                                                                                                                                                                                                             react-simple-dropdown
                                                                                                                                                                                                                             https://github.com/Fauntleroy/react-simple-dropdown
                                                                                                                                                                                                                             Copyright (c) 2015, Timothy Kempf <tim@kemp59f.info>
                                                                                                                                                                                                                             */


/**
 * Optional component to use inside DropdownContent component, it just applies styles to a `<ul>` and wraps DropdownListItem
 */
var DropdownList = function DropdownList(_ref) {
  var children = _ref.children;
  var className = _ref.className;
  var active = _ref.active;

  var props = _objectWithoutProperties(_ref, ['children', 'className', 'active']);

  var classes = (0, _bind2.default)(className, _dropdown2.default.list);

  return _react2.default.createElement(
    'ul',
    _extends({}, props, { className: classes }),
    children
  );
};

DropdownList.defaultProps = {
  className: ''
};

exports.default = DropdownList;