'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _blacklist = require('blacklist');

var _blacklist2 = _interopRequireDefault(_blacklist);

var _constants = require('../constants');

var _constants2 = _interopRequireDefault(_constants);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } /** GridRow.js mostly taken and inspired from Elemental UI.
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * used for Grid functionality
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                * Copyright (c) 2016 Thinkmill Pty Ltd
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                */

/**
 * Component that handles Row part of a Grid system. Syntax is somewhat similar to bootstrap's grid class syntax.
 */

var GridRow = function (_Component) {
  _inherits(GridRow, _Component);

  function GridRow() {
    _classCallCheck(this, GridRow);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(GridRow).apply(this, arguments));
  }

  _createClass(GridRow, [{
    key: 'render',
    value: function render() {
      var gutter = this.props.gutter;

      var rowStyle = {
        display: 'flex',
        flexWrap: 'wrap',
        msFlexWrap: 'wrap',
        WebkitFlexWrap: 'wrap',
        marginLeft: gutter / -2,
        marginRight: gutter / -2
      };

      var props = (0, _blacklist2.default)(this.props, 'className', 'gutter', 'style');

      return _react2.default.createElement('div', _extends({}, props, { style: Object.assign(rowStyle, this.props.style), className: this.props.className }));
    }
  }]);

  return GridRow;
}(_react.Component);

GridRow.defaultProps = {
  gutter: _constants2.default.width.gutter
};

exports.default = GridRow;