'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _input = {
  'container': 'ra_input__container',
  'input': 'ra_input__input ra_styles__pad-1 ra_styles__border-gray',
  'checkbox': 'ra_input__checkbox ra_styles__marg-b-1',
  'error': 'ra_input__error ra_input__input ra_styles__pad-1 ra_styles__border-gray ra_styles__red',
  'label': 'ra_input__label ra_styles__marg-b-1'
};

var _input2 = _interopRequireDefault(_input);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Input component. Takes a label prop and wraps label and input in a div. Takes regular input attributes as props as well
 */

var Input = function (_Component) {
  _inherits(Input, _Component);

  function Input() {
    _classCallCheck(this, Input);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Input).apply(this, arguments));
  }

  _createClass(Input, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var disabled = _props.disabled;
      var label = _props.label;
      var maxLength = _props.maxLength;
      var multiline = _props.multiline;
      var type = _props.type;
      var value = _props.value;

      var others = _objectWithoutProperties(_props, ['disabled', 'label', 'maxLength', 'multiline', 'type', 'value']);

      var cx = _bind2.default.bind(_input2.default);

      var inputClassName = cx({
        "input": type !== 'checkbox',
        "checkbox": type == 'checkbox',
        disabled: disabled,
        multiline: multiline,
        value: value
      });

      if (this.props.className) inputClassName += ' ' + this.props.className;

      return _react2.default.createElement(
        'div',
        { className: _input2.default.container },
        this.props.label ? _react2.default.createElement(
          'label',
          { htmlFor: this.props.htmlFor, className: _input2.default.label },
          label
        ) : null,
        _react2.default.createElement('input', _extends({}, this.props, { className: inputClassName, onChange: this.props.onChange, type: type }))
      );
    }
  }]);

  return Input;
}(_react.Component);

Input.defaultProps = {
  "disabled": false,
  "type": 'text',
  "inputLength": 0,
  "focus": false
};

exports.default = Input;