'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _overlay = {
  'container': 'ra_overlay__container ra_styles__z4',
  'active': 'ra_overlay__active ra_overlay__container ra_styles__z4',
  'inactive': 'ra_overlay__inactive ra_overlay__container ra_styles__z4',
  'overlay': 'ra_overlay__overlay ra_styles__bg-black',
  'overlayActive': 'ra_overlay__overlayActive ra_overlay__overlay ra_styles__bg-black',
  'overlayInactive': 'ra_overlay__overlayInactive ra_overlay__overlay ra_styles__bg-black',
  'invisible': 'ra_overlay__invisible'
};

var _overlay2 = _interopRequireDefault(_overlay);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Overlay component adds a 'shadowbox' to screen. Mostly used internally in the lib on the `<Dialog>` component.
 */

var Overlay = function (_Component) {
  _inherits(Overlay, _Component);

  function Overlay() {
    _classCallCheck(this, Overlay);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Overlay).apply(this, arguments));
  }

  _createClass(Overlay, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.overlay = document.createElement('div');
      this.overlay.setAttribute('data-react-atlas', 'overlay');
      document.body.appendChild(this.overlay);
      this.handleRender();
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      this.handleRender();
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      _reactDom2.default.unmountComponentAtNode(this.overlay);
      document.body.removeChild(this.overlay);
    }
  }, {
    key: 'handleRender',
    value: function handleRender() {
      var _props = this.props;
      var className = _props.className;
      var active = _props.active;
      var invisible = _props.invisible;
      var children = _props.children;
      var onClick = _props.onClick;


      var cx = _bind2.default.bind(_overlay2.default);
      var classNames = cx({
        inactive: !active,
        active: active,
        invisible: invisible,
        className: className
      });

      var overlayClasses = cx({
        overlayActive: active,
        overlayInactive: !active
      });

      _reactDom2.default.render(_react2.default.createElement(
        'div',
        { className: classNames },
        _react2.default.createElement('div', { className: overlayClasses, onClick: onClick }),
        children
      ), this.overlay);
    }
  }, {
    key: 'render',
    value: function render() {
      return null;
    }
  }]);

  return Overlay;
}(_react.Component);

Overlay.defaultProps = {
  invisible: false
};

exports.default = Overlay;