'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _progressBar = {
  'linear': 'ra_progressBar__linear',
  'indeterminate': 'ra_progressBar__indeterminate',
  'value': 'ra_progressBar__value',
  'linear-indeterminate-bar': 'ra_progressBar__linear-indeterminate-bar',
  'buffer': 'ra_progressBar__buffer',
  'circular': 'ra_progressBar__circular',
  'circle': 'ra_progressBar__circle',
  'circular-indeterminate-bar-rotate': 'ra_progressBar__circular-indeterminate-bar-rotate',
  'path': 'ra_progressBar__path',
  'circular-indeterminate-bar-dash': 'ra_progressBar__circular-indeterminate-bar-dash',
  'multicolor': 'ra_progressBar__multicolor',
  'colors': 'ra_progressBar__colors'
};

var _progressBar2 = _interopRequireDefault(_progressBar);

var _prefixer = require('../utils/prefixer');

var _prefixer2 = _interopRequireDefault(_prefixer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

//TODO Change this to a self contained component from the current version that requires too much logic in the parent component

var ProgressBar = function (_React$Component) {
  _inherits(ProgressBar, _React$Component);

  function ProgressBar() {
    _classCallCheck(this, ProgressBar);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(ProgressBar).apply(this, arguments));
  }

  _createClass(ProgressBar, [{
    key: 'calculateRatio',
    value: function calculateRatio(value) {
      if (value < this.props.min) return 0;
      if (value > this.props.max) return 1;
      return (value - this.props.min) / (this.props.max - this.props.min);
    }
  }, {
    key: 'circularStyle',
    value: function circularStyle() {
      if (this.props.mode !== "indeterminate") {
        return { strokeDasharray: 2 * Math.PI * 25 * this.calculateRatio(this.props.value) + ', 400' };
      }
    }
  }, {
    key: 'linearStyle',
    value: function linearStyle() {
      if (this.props.mode !== "indeterminate") {
        return {
          buffer: (0, _prefixer2.default)({ transform: 'scaleX(' + this.calculateRatio(this.props.buffer) + ')', transitionDuration: this.props.transitionDuration }),
          value: (0, _prefixer2.default)({ transform: 'scaleX(' + this.calculateRatio(this.props.value) + ')', transitionDuration: this.props.transitionDuration })
        };
      } else {
        return {};
      }
    }
  }, {
    key: 'renderCircular',
    value: function renderCircular() {
      return _react2.default.createElement(
        'svg',
        { className: _progressBar2.default.circle },
        _react2.default.createElement('circle', { className: _progressBar2.default.path, style: this.circularStyle(), cx: '30', cy: '30', r: '25' })
      );
    }
  }, {
    key: 'renderLinear',
    value: function renderLinear() {
      var _linearStyle = this.linearStyle();

      var buffer = _linearStyle.buffer;
      var value = _linearStyle.value;

      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement('span', { ref: 'buffer', 'data-ref': 'buffer', className: _progressBar2.default.buffer, style: buffer }),
        _react2.default.createElement('span', { ref: 'value', 'data-ref': 'value', className: _progressBar2.default.value, style: value })
      );
    }
  }, {
    key: 'renderRange',
    value: function renderRange() {
      var rangeStyle = (0, _prefixer2.default)({
        transform: 'translateX(' + this.calculateRatio(this.props.value.from) * 100 + '%) \n                   scaleX(' + this.calculateRatio(this.props.value.to - this.props.value.from) + ')'
      });
      return _react2.default.createElement('span', { ref: 'value', 'data-ref': 'value', className: _progressBar2.default.value, style: rangeStyle });
    }
  }, {
    key: 'renderInner',
    value: function renderInner() {
      if (this.props.type === 'circular') return this.renderCircular();
      if (isNaN(this.props.value)) return this.renderRange();
      return this.renderLinear();
    }
  }, {
    key: 'render',
    value: function render() {
      var _cx;

      var _props = this.props;
      var buffer = _props.buffer;
      var type = _props.type;
      var mode = _props.mode;
      var value = _props.value;
      var min = _props.min;
      var max = _props.max;

      var props = _objectWithoutProperties(_props, ['buffer', 'type', 'mode', 'value', 'min', 'max']);

      var cx = _bind2.default.bind(_progressBar2.default);
      var classes = cx((_cx = {}, _defineProperty(_cx, this.props.type, this.props.type), _defineProperty(_cx, this.props.mode, this.props.mode), _cx), this.props.className);

      return _react2.default.createElement(
        'div',
        {
          'aria-valuenow': value,
          'aria-valuemin': min,
          'aria-valuemax': max,
          className: classes
        },
        this.renderInner()
      );
    }
  }]);

  return ProgressBar;
}(_react2.default.Component);

ProgressBar.defaultProps = {
  buffer: 0,
  className: '',
  max: 100,
  min: 0,
  transitionDuration: '.35s',
  mode: 'indeterminate',
  multicolor: false,
  type: 'linear',
  value: 0
};

exports.default = ProgressBar;