'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _radio = {
  'block': 'ra_radio__block ra_styles__marg-b-1',
  'inline': 'ra_radio__inline ra_styles__marg-r-2',
  'disabled': 'ra_radio__disabled ra_styles__gray'
};

var _radio2 = _interopRequireDefault(_radio);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

var Radio = function Radio(_ref) {
  var className = _ref.className;
  var disabled = _ref.disabled;
  var inline = _ref.inline;
  var name = _ref.name;
  var label = _ref.label;

  var props = _objectWithoutProperties(_ref, ['className', 'disabled', 'inline', 'name', 'label']);

  var cx = _bind2.default.bind(_radio2.default);

  var labelClassName = cx({
    block: !inline,
    inline: inline,
    disabled: disabled,
    className: className
  });

  return _react2.default.createElement(
    'label',
    { className: labelClassName },
    _react2.default.createElement('input', _extends({}, props, {
      disabled: disabled,
      name: name,
      type: 'radio'
    })),
    label ? _react2.default.createElement(
      'span',
      null,
      ' ',
      label
    ) : null
  );
};

Radio.defaultProps = {
  className: '',
  disabled: false,
  inline: false
};

exports.default = Radio;