'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _switch = {
  'slider': 'ra_switch__slider',
  'sliderSmall': 'ra_switch__sliderSmall ra_switch__slider',
  'sliderMedium': 'ra_switch__sliderMedium ra_switch__slider',
  'sliderLarge': 'ra_switch__sliderLarge ra_switch__slider',
  'handle': 'ra_switch__handle',
  'handleSmall': 'ra_switch__handleSmall ra_switch__handle',
  'handleMedium': 'ra_switch__handleMedium ra_switch__handle',
  'handleLarge': 'ra_switch__handleLarge ra_switch__handle',
  'input': 'ra_switch__input',
  'inputSmall': 'ra_switch__inputSmall ra_switch__input',
  'inputMedium': 'ra_switch__inputMedium ra_switch__input',
  'inputLarge': 'ra_switch__inputLarge ra_switch__input',
  'onColor': 'ra_switch__onColor',
  'onColorSmall': 'ra_switch__onColorSmall ra_switch__onColor',
  'onColorMedium': 'ra_switch__onColorMedium ra_switch__onColor',
  'onColorLarge': 'ra_switch__onColorLarge ra_switch__onColor',
  'disabled': 'ra_switch__disabled',
  'black': 'ra_switch__black ra_styles__bg-black',
  'gray': 'ra_switch__gray ra_styles__bg-gray',
  'silver': 'ra_switch__silver ra_styles__bg-silver',
  'white': 'ra_switch__white ra_styles__bg-white',
  'blue': 'ra_switch__blue ra_styles__bg-blue',
  'green': 'ra_switch__green ra_styles__bg-green',
  'yellow': 'ra_switch__yellow ra_styles__bg-yellow',
  'red': 'ra_switch__red ra_styles__bg-red',
  'purple': 'ra_switch__purple ra_styles__bg-purple'
};

var _switch2 = _interopRequireDefault(_switch);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Switch = function (_React$Component) {
  _inherits(Switch, _React$Component);

  function Switch() {
    _classCallCheck(this, Switch);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Switch).apply(this, arguments));
  }

  _createClass(Switch, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var checked = _props.checked;
      var disabled = _props.disabled;
      var inline = _props.inline;
      var name = _props.name;
      var slider = _props.slider;
      var small = _props.small;
      var medium = _props.medium;
      var large = _props.large;
      var onColor = _props.onColor;
      var offColor = _props.offColor;
      var buttonColor = _props.buttonColor;


      var cx = _bind2.default.bind(_switch2.default);

      var offClassName = cx({
        sliderSmall: small && !medium && !large,
        sliderMedium: !small && !large,
        sliderLarge: large && !medium && !small,
        disabled: disabled
      });

      var inputClassName = cx({
        inputSmall: small && !medium && !large,
        inputMedium: !small && !large,
        inputLarge: large && !medium && !small,
        disabled: disabled
      });

      var buttonClassName = cx({
        handleSmall: small && !medium && !large,
        handleMedium: !small && !large,
        handleLarge: large && !medium && !small,
        disabled: disabled
      });

      var onClassName = cx({
        onColorSmall: small && !medium && !large,
        onColorMedium: !small && !large,
        onColorLarge: large && !medium && !small
      });

      var offColorStyle = {
        background: offColor
      };

      var onColorStyle = {
        background: onColor
      };

      var buttonColorStyle = {
        background: buttonColor
      };

      return _react2.default.createElement(
        'label',
        { className: offClassName, style: offColorStyle },
        _react2.default.createElement('input', { className: inputClassName, style: onColorStyle, type: 'checkbox' }),
        _react2.default.createElement('div', { className: buttonClassName, style: buttonColorStyle }),
        _react2.default.createElement('div', { className: onClassName, style: onColorStyle })
      );
    }
  }]);

  return Switch;
}(_react2.default.Component);

Switch.defaultProps = {
  checked: false,
  className: '',
  disabled: false
};

exports.default = Switch;