'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _tabs = {
  'container': 'ra_tabs__container ra_styles__pad-0 ra_styles__marg-b-0',
  'navigation': 'ra_tabs__navigation ra_styles__border-bottom ra_styles__border-gray',
  'tab': 'ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top',
  'label': 'ra_tabs__label ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top ra_styles__cursor-pointer',
  'active': 'ra_tabs__active ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top ra_styles__cursor-default ra_styles__bg-white',
  'disabled': 'ra_tabs__disabled ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top ra_styles__cursor-not-allowed',
  'hidden': 'ra_tabs__hidden ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top',
  'pointer': 'ra_tabs__pointer',
  'tabContent': 'ra_tabs__tabContent ra_styles__pad-v-2 ra_styles__pad-h-2',
  'tabActive': 'ra_tabs__tabActive'
};

var _tabs2 = _interopRequireDefault(_tabs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Individual Tab component used within `<Tabs>`. Can be disabled, hidden and also sent an onActive event trigger. Children become `<TabContent>`.
 */

var Tab = function (_Component) {
  _inherits(Tab, _Component);

  function Tab() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    _classCallCheck(this, Tab);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(Tab)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this._handleClick = function () {
      if (!_this.props.disabled && _this.props.onClick) {
        _this.props.onClick();
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Tab, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      if (!prevProps.active && this.props.active && this.props.onActive) {
        this.props.onActive();
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var active = _props.active;
      var hidden = _props.hidden;
      var disabled = _props.disabled;
      var label = _props.label;


      var cx = _bind2.default.bind(_tabs2.default);

      var className = cx({
        label: !active && !hidden && !disabled,
        active: active,
        hidden: hidden,
        disabled: disabled
      }, this.props.className);

      return _react2.default.createElement(
        'label',
        { className: className, onClick: this._handleClick },
        label
      );
    }
  }]);

  return Tab;
}(_react.Component);

Tab.defaultProps = {
  active: false,
  className: '',
  disabled: false,
  hidden: false,
  label: 'Tab Title'
};

exports.default = Tab;