'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _tabs = {
  'container': 'ra_tabs__container ra_styles__pad-0 ra_styles__marg-b-0',
  'navigation': 'ra_tabs__navigation ra_styles__border-bottom ra_styles__border-gray',
  'tab': 'ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top',
  'label': 'ra_tabs__label ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top ra_styles__cursor-pointer',
  'active': 'ra_tabs__active ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top ra_styles__cursor-default ra_styles__bg-white',
  'disabled': 'ra_tabs__disabled ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top ra_styles__cursor-not-allowed',
  'hidden': 'ra_tabs__hidden ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top',
  'pointer': 'ra_tabs__pointer',
  'tabContent': 'ra_tabs__tabContent ra_styles__pad-v-2 ra_styles__pad-h-2',
  'tabActive': 'ra_tabs__tabActive'
};

var _tabs2 = _interopRequireDefault(_tabs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Used within the `<Tabs>` Component to programatically determine the content of any given tab. There probably isn't any reason for you to actually use `<TabContent>` directly.
 */
var TabContent = function TabContent(_ref) {
  var active = _ref.active;
  var tabIndex = _ref.tabIndex;
  var children = _ref.children;
  var className = _ref.className;

  var cx = _bind2.default.bind(_tabs2.default);
  var classNames = cx({
    tabContent: true,
    tabActive: active
  }, className);

  return _react2.default.createElement(
    'section',
    { className: classNames, tabIndex: tabIndex },
    children
  );
};

TabContent.defaultProps = {
  active: false,
  className: ''
};

exports.default = TabContent;