"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _Tab = require("./Tab");

var _Tab2 = _interopRequireDefault(_Tab);

var _TabContent = require("./TabContent");

var _TabContent2 = _interopRequireDefault(_TabContent);

var _tabs = {
  "container": "ra_tabs__container ra_styles__pad-0 ra_styles__marg-b-0",
  "navigation": "ra_tabs__navigation ra_styles__border-bottom ra_styles__border-gray",
  "tab": "ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top",
  "label": "ra_tabs__label ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top ra_styles__cursor-pointer",
  "active": "ra_tabs__active ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top ra_styles__cursor-default ra_styles__bg-white",
  "disabled": "ra_tabs__disabled ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top ra_styles__cursor-not-allowed",
  "hidden": "ra_tabs__hidden ra_tabs__tab ra_styles__pad-v-2 ra_styles__pad-h-2 ra_styles__black ra_styles__border ra_styles__border-transparent ra_styles__rounded-top",
  "pointer": "ra_tabs__pointer",
  "tabContent": "ra_tabs__tabContent ra_styles__pad-v-2 ra_styles__pad-h-2",
  "tabActive": "ra_tabs__tabActive"
};

var _tabs2 = _interopRequireDefault(_tabs);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/**
 * Wrapper component to organize and produce tabs using multiple `<Tab>` components as children.
 */

var Tabs = function (_Component) {
  _inherits(Tabs, _Component);

  function Tabs() {
    var _Object$getPrototypeO;

    var _temp, _this, _ret;

    _classCallCheck(this, Tabs);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_Object$getPrototypeO = Object.getPrototypeOf(Tabs)).call.apply(_Object$getPrototypeO, [this].concat(args))), _this), _this._handleHeaderClick = function (idx) {
      if (_this.props.onChange) _this.props.onChange(idx);
    }, _this._parseChildren = function () {
      var headers = [];
      var contents = [];

      _react2.default.Children.forEach(_this.props.children, function (item) {
        if (item.type === _Tab2.default) {
          headers.push(item);
          if (item.props.children) {
            contents.push(_react2.default.createElement(_TabContent2.default, { children: item.props.children }));
          }
        } else if (item.type === _TabContent2.default) {
          contents.push(item);
        }
      });

      return { headers: headers, contents: contents };
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Tabs, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      var _parseChildren = this._parseChildren();

      var headers = _parseChildren.headers;
      var contents = _parseChildren.contents;


      var className = _tabs2.default.container;
      if (this.props.className) className += " " + this.props.className;

      return _react2.default.createElement(
        "div",
        { className: className },
        _react2.default.createElement(
          "nav",
          { className: _tabs2.default.navigation, ref: "navigation" },
          headers.map(function (item, idx) {
            return _react2.default.createElement(_Tab2.default, _extends({}, item.props, { key: idx, active: _this2.props.index === idx, onClick: _this2._handleHeaderClick.bind(_this2, idx) }));
          })
        ),
        contents.map(function (item, idx) {
          return _react2.default.createElement(_TabContent2.default, _extends({}, item.props, { key: idx, active: _this2.props.index === idx, tabIndex: idx }));
        })
      );
    }
  }]);

  return Tabs;
}(_react.Component);

Tabs.defaultProps = {
  index: 0
};

exports.default = Tabs;