'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _bind = require('classnames/bind');

var _bind2 = _interopRequireDefault(_bind);

var _tooltip = {
  'tooltip': 'ra_tooltip__tooltip',
  'block': 'ra_tooltip__block',
  'tooltip-top': 'ra_tooltip__tooltip-top',
  'tooltip-left': 'ra_tooltip__tooltip-left',
  'tooltip-bottom': 'ra_tooltip__tooltip-bottom',
  'tooltip-right': 'ra_tooltip__tooltip-right'
};

var _tooltip2 = _interopRequireDefault(_tooltip);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
 * A CSS driven tooltip that gives more information when an element it wraps is hovered over.
 */

var Tooltip = function (_Component) {
  _inherits(Tooltip, _Component);

  function Tooltip() {
    _classCallCheck(this, Tooltip);

    return _possibleConstructorReturn(this, Object.getPrototypeOf(Tooltip).apply(this, arguments));
  }

  _createClass(Tooltip, [{
    key: 'render',
    value: function render() {
      var _props2;

      var _props = this.props;
      var children = _props.children;
      var position = _props.position;
      var tooltip = _props.tooltip;
      var inline = _props.inline;

      var other = _objectWithoutProperties(_props, ['children', 'position', 'tooltip', 'inline']);

      var cx = _bind2.default.bind(_tooltip2.default);
      var tooltipClasses = void 0;
      if (!children.props.disabled) {
        var _cx;

        tooltipClasses = cx((_cx = {}, _defineProperty(_cx, "tooltip", true), _defineProperty(_cx, "tooltip-top", position !== 'left' && position !== 'bottom' && position !== 'right'), _defineProperty(_cx, "tooltip-left", position === 'left'), _defineProperty(_cx, "tooltip-bottom", position === 'bottom'), _defineProperty(_cx, "tooltip-right", position === 'right'), _cx));
      }
      tooltipClasses = tooltipClasses ? tooltipClasses : '';

      var element = inline ? 'span' : 'div';

      var props = (_props2 = {}, _defineProperty(_props2, 'data-tooltip', tooltip), _defineProperty(_props2, 'className', _tooltip2.default.block + ' ' + tooltipClasses), _props2);

      return _react2.default.createElement(element, props, children);
    }
  }]);

  return Tooltip;
}(_react.Component);

Tooltip.defaultProps = {
  className: '',
  children: _react2.default.createElement(
    'p',
    null,
    'This is some text with tooltip'
  ),
  tooltip: 'Sample Tooltip Text'
};

exports.default = Tooltip;